import java.awt.Shape;
import java.awt.geom.GeneralPath;
import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;

/**
 * Diese Klasse Kompositum wurde nach Anforderungen programmiert:
 * fuegeHinzu: es wird nur ein Moebel hinzugefgt, das noch nicht enthalten ist.
 * enthalten : muss daher implementiert sein
 * entferne  : es kann nur ein Moebel entfernt werden, das enthalten ist.
 * 
 * @author claus albowski
 * @version 
 */
public class Kompositum extends Moebel
{
    // Instanzvariable
    ArrayList<Moebel> moebelListe;

    /**
     * Konstruktor fr Objekte der Klasse Kompositum
     */
    public Kompositum()
    {
        // Instanzvariable initialisieren
        moebelListe = new ArrayList<Moebel>();
        xPosition = 0;
        yPosition = 0;
        orientierung = 0;
        farbe = "blau";
        istSichtbar = false;
    }

    /**
     * Bestimmt das zu zeichnende Shape durch Weiterreichen der Anforderung
     * an die Kindobjekte und Verknpfen ber einen GeneralPath.
     */
    protected Shape gibAktuelleFigur(){
        GeneralPath figur = new GeneralPath();
        for (Iterator it=moebelListe.iterator(); it.hasNext();){
            figur.append(((Moebel)it.next()).gibAktuelleFigur(),false);
        }
        return transformiere(figur);
    }

    // Die klassischen Kompositummethoden
  
    /**
     * fuegeHinzu()
     */
    public boolean fuegeHinzu(Moebel moebel){
        if (!enthaelt(moebel)){
            moebelListe.add(moebel);
            return true;
        }
        else return false;
    }
    
    /**
     * enthaelt
     * prueft, ob ein Moebel im Kompositum enthalten ist
     */
    public boolean enthaelt(Moebel moebel){
        return moebelListe.contains(moebel);
    }
    
    /**
     * entferne
     */
    public Moebel entferne(Moebel moebel){
        if (enthaelt(moebel)){
            Moebel temp = moebel;
            moebelListe.remove(moebel);
            return temp;
        } else{
            return null;
        }
    }
}
